#ifndef Map_H
#define Map_H

#include <Bild.h>

using namespace Framework;

struct Pos
{
	short x;
	short y;
};

class Map
{
private:
	Array< Pos > *schlange;
	Array< Pos > *ziele;
	LRahmen *feld;
	LRahmen *kam;
	LRahmen *map;
	Pos kamPos;
	bool move;
	int score;
	int breite;
	int hhe;
	int geschwindigkeit;
	int zAnzahl;
	double next;
	int richtung;
	bool beendet;
	int addAnzahl;
	int neuAnzahl;
	bool sr;
	bool rend;
	int ref;

public:
	// Konstruktor
	Map();
	// Destruktor
	~Map();
	// nicht constant
	void reset();
	void doMausEreignis( MausEreignis &me );
	void doTastaturEreignis( TastaturEreignis &te );
	bool tick( double tickVal );
	void render( Bild &zRObj );
	// constant
	void speichern() const;
	int getScore() const;
	bool istBeendet() const;
	// Reference Counting
	Map *getThis();
	Map *release();
};

#endif